#!/bin/bash
# for upgrading see also
# http://debgen.simplylinux.ch/
#
# $1 = dir
# $2 = apt-key
# $3 = apt-get
# $4 = $WGET

REPLACE=yes
DL=yes
KS=yes
APT=yes
APTDIR=/etc/apt
APTKEY=`which apt-key`


while [ "$1" != "" ]; do
  case $1 in
     -h)
      echo "Usage: /etc/apt/getkeys.sh [ -replace | -add ] [ -[no-]dl ] [ -[no-]keyserver ] [ -[no-]aptget ] [ -apt-key APTKEYSCRIPT ] [ APTDIR ]"
         exit 0
         ;;
     -add)
         REPLACE=no
         shift
         ;;
     -replace)
         REPLACE=yes
         shift
         ;;
     -dl)
         DL=yes
         shift
         ;;
     -no-dl)
         DL=no
         shift
         ;;
     -keyserver)
         KS=yes
         shift
         ;;
     -no-keyserver)
         KS=no
         shift
         ;;
     -aptget)
         APT=yes
         shift
         ;;
     -no-aptget)
         APT=no
         shift
         ;;
     -apt-key)
         APTKEY=$2
         shift
         shift
         ;;
     *) 
	 APTDIR=$1
         shift
	 ;;
   esac
done


_getkeyfromserver () {
    if [ $KS = yes ]; then 
	echo "Installing key for $2 ..."
	gpg --keyserver pgp.mit.edu --recv-keys 0x$1 && gpg --export --armor 0x$1 | $APTKEY add -
    else
	echo "Disabled Installing key for $2 ..."
	echo "CALL BY HAND: gpg --keyserver pgp.mit.edu --recv-keys 0x$1 && gpg --export --armor 0x$1 | $APTKEY add -"
    fi
}

_getviaapt () {
    if [ $APT = yes ]; then 
	echo "Installing key for $2 ..."
	apt-get --reinstall --force-yes --yes install $1
    else
	echo "Disabled Installing key for $2 ..."
	echo "CALL BY HAND: apt-get --reinstall --yes install $1"
    fi
}

_getviawget () {
    if [ $DL = yes ]; then 
	echo "Installing key for $2 ..."
	wget -q -O - $1 | $APTKEY add -
    else
	echo "Disabled installing key for $2..."
	echo "CALL BY HAND: wget -q -O - $1 | $APTKEY add -"
    fi
}

_saveandrmfile () {
	if [ -f ${1}.4 ]; then rm ${1}.4 ; fi
	if [ -f ${1}.3 ]; then mv ${1}.3 ${1}.4 ; fi
	if [ -f ${1}.2 ]; then mv ${1}.2 ${1}.3 ; fi
	if [ -f ${1}.1 ]; then mv ${1}.1 ${1}.2 ; fi
	if [ -f ${1}   ]; then 
           mv ${1}   ${1}.1 ; 
	   touch ${1}
	   chmod 600 ${1}
        fi
}

# _getkeyfromserver ADB11277 # etch
# _getkeyfromserver F42584E6 # lenny
# _getkeyfromserver 55BE302B # lenny
# _getkeyfromserver 6D849617 # lenny volatile

# General Keys
if [ $APT = yes ]; then
  apt-get update && apt-get install debian-archive-keyring
fi

if [ $REPLACE = yes ]; then
#  echo "Removing all keys ..."
#  _saveandrmfile $APTDIR/trustdb.gpg
#  _saveandrmfile $APTDIR/trusted.gpg

  echo "Regenerating base debian keys ..."
  $APTKEY update
fi

_getviawget http://debutil.the-m.at/develop_the-m_at.asc debutil.the-m.at

for resfile in $APTDIR/sources.list.d/*.list; do 
   sn=`basename "$resfile" | cut -d. -f1`
   scriptfile=$APTDIR/getkeys.d/$sh.sh
   if [ -f $scriptfile ]; then
     echo "Sourcing $scriptfile"
     source $scriptfile
   fi
done

# _getviawget http://78.104.88.70/debian/fhmserv1_repository_key.asc 78.104.88.70

# Specific Keys from http://debgen.simplylinux.ch/
# apt-get update && 

# _getviawget http://www.debian.org/volatile/lenny-volatile.asc "Volatile"

# _getviaapt debian-multimedia-keyring debian-multimedia

# _getviaapt debian-unofficial-archive-keyring debian-unofficial

# _getviawget https://dl-ssl.google.com/linux/linux_signing_key.pub "google repository"

# _getkeyfromserver 0xd66b746e "skype"
# _getkeyfromserver d66b746e skype
# ??? _getkeyfromserver A79F93C3 "w3you"

# _getviawget http://deb.opera.com/archive.key opera

#_getviaapt dmo-archive-keyring unofficial.debian-maintainers.org
# _getviawget http://unofficial.debian-maintainers.org/project/openpgp/archive-key.asc "Unofficial Maintainers"

# _getviaapt debian-backports-keyring www.backports.org
# _getviawget http://repo.palatinus.cz/repo.key palatinus.cz

#_getviawget http://download.virtualbox.org/virtualbox/debian/sun_vbox.asc "Sun Virtualbox (sun)"
# _getviawget http://download.virtualbox.org/virtualbox/debian/oracle_vbox.asc "Sun Virtualbox (oracle)"

# _getviawget http://www.webmin.com/jcameron-key.asc Webmin

# _getviawget http://apt.wicd.net/wicd.gpg wicd

#_getviawget http://wine.budgetdedicated.com/apt/387EE263.gpg wine
#_getviawget http://www.lamaresh.net/apt/key.gpg wine 

# _getviawget http://xpra.devloop.org.uk/gpg.asc xpra
# _getviawget http://shifter.devloop.org.uk/gpg.asc shifter
# _getviawget http://winswitch.org/gpg.asc "shifter xpra"



